% test your implementation against provided ground truth data
function [] = test() 

load('camera_matrices_dev.mat'); 
load('images_dev.mat'); 
num_cameras = length(camera_matrices); 
occlusions = cell(num_cameras, 1) ; 
for i=1:num_cameras 
  occlusions{i} = zeros(length(images{i}),1); 
end

% test projections 
voxel_corner = [0 3 -10]; 
projections = voxel_projections(voxel_corner, camera_matrices, images, 0.1);   
assert(sum(reshape(sort(projections{15}),1,length(projections{15})) == 177:180) == length(projections{15}))

voxel_corner = [0 -2 -11]; 
projections = voxel_projections(voxel_corner, camera_matrices, images, 0.1); 
assert(sum(reshape(sort(projections{15}),1,length(projections{15})) == 270:273) == length(projections{15}))

disp('Passed projections'); 


% test photoconsistency
% if you implement photoconsistency in a way different from the paper, please adjust threshold and sigma_0 accordingly  
voxel_corner = [0,0,-10]; 
projections = voxel_projections(voxel_corner, camera_matrices, images, 0.05);   
assert(photoconsistent(projections, images, occlusions, 0.0625, 3.1) == 1)


voxel_corner = [0,3,-10]; 
projections = voxel_projections(voxel_corner, camera_matrices, images, 0.05);   
assert(photoconsistent(projections, images, occlusions, 0.0625, 3.1) == 0)

disp('Passed photoconsistency')
